<?php 
  // Eine Datei mit Kennwoertern im Klartext oeffnen, zeilenweise lesen. 
  // Fuer jede Zeile eine MD5 Hash berechnen und auf der Konsole ausgeben.
  // Das Programm muss in dieser Form in einem "schwarzen Fenster" ablaufen.
  // Erwartet die Kennwoerter im Klartext in einer Datei "kennwoerter.txt"
  // im lokalen Verzeichnis.
  // Hinweis: die erzeugten Kennwoerter koennen per Redirection in eine
  //   Datei geschrieben werden, z.B. so:
  //   php -f php_md5.php >neue_kennwoerter.txt
  //
  // Dr.Edgar Huckert 11-2010
  
  // --------------------------------------------------
  // Liefert einen Zufallswert
  function makeRandom()
  {
    $salt = "";
    for ($i=0; $i <= 32; $i++) 
    {
      $d = rand(1,30) % 2;
      $salt .= $d ? chr(rand(65,90)) : chr(rand(48,57));
    }
    return $salt;
  }    

  // ---------------------------------------------------
  // Liefert einen MD5 Hash
  function makeHash($inp)
  {
    $line = trim($line);
    $hashed = md5($inp);
    return $hashed;
  }
  //
  // ---------------------------------------------------
  // Start Hauptprogramm hier
  $file = ".\kennwoerter.txt"; 
  if (file_exists ($file))
  { 
    try 
    { 
      if ($fh = fopen ($file, "r"))
      { 
          //echo "File ".$file." opened successfully.\n"; 
          for ($line = fgets($fh); ! feof($fh); $line = fgets($fh)) 
          {
            $line = trim($line);
            //print "read:".$line."\n";
            $zufall = makeRandom();
            $newPassword = makeHash($line.$zufall);
            //print "MD5 hashed: ".$newPassword."\n";
            print $newPassword."\n";
          }
          fclose($fh);
      }
      else 
      { 
        throw new exception ("Sorry, the file could not be opened."); 
      } 
    } 
    catch (exception $e) 
    { 
      echo $e->getmessage(); 
    } 
  } 
  else 
  {
    echo "File ".$file. " does not exist."; 
  } 
?>
